/**************************************/
/*  keisoku.c                         */
/*  @vL^͏vO      */
/**************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "common.h"
#include "main.h"
#include "keisoku.h"

extern int akicode_tbl[ MEMBER_MAX + 1 ];                  /* 󂫃R[h\           */
extern int codedata_tbl[ MEMBER_MAX ];                     /* R[hEf[^Ώƕ\   */
extern struct KEISOKU_TBL kojin_keisoku_tbl;               /* lʌvf[^\     */
extern struct KEISOKU_TBL sort_keisoku_tbl[ MEMBER_MAX ];  /* \[gpvf[^\   */


/* ͌vf[^e[u */
static struct  KEISOKU_INPUT   keisoku_indata[ 5 ];

/************************************/
/* vL^͏                 */
/*   C[`                 */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
int keisoku_input( void )
{
    int     ret;                /* ^[R[h    */
    int     i;                  /* CfbNX      */
    int     kaiin_code;         /* vR[h    */
    int     undou_sisuu;        /* Zo^w      */
    char    msg[ 64 ];          /* bZ[WGA  */
    char    keisoku_date[ 9 ];  /* vt          */

    /* 󂫃R[h\ READ -> NG ? */
    if( (ret = akicode_tbl_read( )) == NG ) {
        return ret;
    }

    /* ҃`FbN */
    if( akicode_tbl[ 0 ] >= MEMBER_MAX ) {
        printf( "\n ݁C҂܂" );
        return NG;
    }

    /* R[hEf[^Ώƕ\t@C READ -> NG ? */
    if( (ret = codedata_tbl_read( )) == NG ) {
        return ret;
    }

    /* vR[h */
    kaiin_code_input( &kaiin_code );

    /* vt */
    keisoku_date_input( keisoku_date );

    /* vl͏ */
    for( i = 0; i < 5; i++ ) {
        keisoku_data_input( i );
    }

    /* ̓f[^\ */
    keisoku_data_disp( kaiin_code, keisoku_date );

    /* ͊mF */
    strcpy( msg, "\n ͂͂낵ł( Y/N )" );

    /* 'N' OR 'n' -> OK łȂ ? */
    if( (ret = kakunin_input( msg )) != OK ) {
        return NG;
    }

    /* vf[^\ READ -> NG ? */
    if( (ret = kojin_data_read( kaiin_code )) == NG ) {
        return ret;
    }

    /* vlvZ */
    undou_sisuu_keisan( &undou_sisuu );

    /* vf[^\ SET */
    kojin_data_update( kaiin_code, keisoku_date, undou_sisuu );

    /* vʃf[^\ */
    kojin_data_disp( kaiin_code, "\n ** vʃf[^ **" );

    /* L[͑҂ */
    while( getchar( ) != '\n' ) ;
    printf( "\n ^[L[Ă" );
    getchar( );

    /* vʏʃ\[g\ */
    ret = keisoku_rank( );

    return ret;
}



/**************************************/
/* vL^͏                   */
/*   R[hEf[^Ώƕ\@Ǎݏ */
/*                                    */
/*   p[^ : Ȃ                */
/*   ^[   : 0:OK                */
/*               -1:NG                */
/**************************************/
static int codedata_tbl_read( void )
{
    int     ret;                        /* ^[R[h               */
    FILE    *fp;                        /* t@C|C^             */
    char    *fname = CODEDATA_TBL_NAME; /* R[hEf[^Ώƕ\t@C */

    /* R[hEf[^Ώƕ\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n R[hEf[^Ώƕ\t@C OPEN G[" );
        return NG;
    }

    /* R[hEf[^Ώƕ\t@C READ -> 1ȊO ? */
    if( (ret = fread( (char *)codedata_tbl, sizeof( codedata_tbl ), 1, fp ))
               != 1 ) {
        printf( "\n R[hEf[^Ώƕ\t@C READ G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* R[hEf[^Ώƕ\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* vL^͏                 */
/*   R[h͏             */
/*                                  */
/*   p[^ : ͉R[h    */
/*   ^[   : Ȃ              */
/************************************/
static void kaiin_code_input( int *kaiin_code )
{
    int     loop = TRUE;    /* [vtO */
    char    work[ 128 ];    /* ̓[N   */

    while( loop ) {
        printf( "\n v҂̉R[h͂Ă" );
        printf( "\n ? " );

        /* R[h */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* j[bNE`FbN -> lȊO ? */
        if( strspn( work, "1234567890" ) < strlen( work ) ) {
            printf( "\n lȊO͂܂" );
            continue;
        }

        /* ͔͈̓`FbN( 0 < kaiin_code <= MEMBER_MAX ) */
        *kaiin_code = atoi( work );
        if( *kaiin_code > MEMBER_MAX || *kaiin_code <= 0 ) {
            printf( "\n ̓~Xł" );
            continue;
        }

        /* R[ho^`FbN -> o^ ? */
        if( codedata_tbl[ *kaiin_code - 1 ] == 0 ) {
            printf( "\n ̉R[h͖o^ł" );
            continue;
        }
        break;
    }
    return;
}



/************************************/
/* vL^͏                 */
/*   vt͏               */
/*                                  */
/*   p[^ : ͓t          */
/*   ^[   : Ȃ              */
/************************************/
static void keisoku_date_input( char *keisoku_date )
{
    int     loop = TRUE;    /* [vtO  */
    int     chk_date;       /* tl      */
    char    conv[ 3 ];      /* lϊp    */
    char    work[ 128 ];    /* ̓[N    */

    while( loop ) {
        printf( "\n t͂Ă( YYYYMMDD )" );
        printf( "\n ? " );

        /* t */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ͌`FbN -> 8ȊO ? */
        if( strlen( work ) != 8 ) {
            printf( "\n ̓~Xł" );
            continue;
        }

        /* j[bNE`FbN -> lȊO ? */
        if( strspn( work, "1234567890" ) < strlen( work ) ) {
            printf( "\n lȊO͂܂" );
            continue;
        }

        /* `FbN */
        conv[0] = work[4];
        conv[1] = work[5];
        conv[2] = '\0';

        chk_date = atoi( conv );
        if( chk_date > 12 || chk_date < 1 ) {
            printf( "\n t(  )̓G[ł" );
            continue;
        }

        /* `FbN */
        conv[0] = work[6];
        conv[1] = work[7];
        conv[2] = '\0';
        chk_date = atoi( conv );
        if( chk_date > 31 || chk_date < 1 ) {
            printf( "\n t(  )̓G[ł" );
            continue;
        }

        break;
    }

    /* ̓f[^ Zbg */
    strcpy(keisoku_date, work);
    return;
}



/************************************/
/* vL^͏                 */
/*   vf[^͏             */
/*                                  */
/*   p[^ : CfbNX      */
/*   ^[   : Ȃ              */
/************************************/
static void keisoku_data_input( int idx )
{
    int     i;                  /* CfbNX   */
    int     loop = TRUE;        /* [vtO   */
    char    work[ 3 ][ 128 ];   /* ̓[N     */

    while( loop ) {
        printf( "\n ^ %d ̌vf[^͂Ă", idx + 1 );
        printf( "\n   ( 999 )  Zbg( 100 )  ( 100 )" );
        printf( "\n ? " );

        /* vf[^ */
        work[ 0 ][ 0 ] = '\0';
        work[ 1 ][ 0 ] = '\0';
        work[ 2 ][ 0 ] = '\0';
        scanf( "%s %s %s", work[ 0 ], work[ 1 ], work[ 2 ] );

        for( i = 0; i < 3; i++ ) {

            /* ͌`FbN -> 3傫 ? */
            if( strlen( work[ i ] ) > 3 ) {
                printf( "\n ̓~Xł" );
                break;
            }

            /* j[bNE`FbN -> lȊO ? */
            if( strspn( work[ i ], "1234567890" ) < strlen( work[ i ] ) ) {
                printf( "\n lȊO͂܂" );
                break;
            }

            /* ׈ȊȌ`FbN -> 100傫 ? */
            if( i != 0 ) {
                if( atoi( work[ i ] ) > 100 ) {
                    printf( "\n ( 100 )𒴂Ă܂" );
                    break;
                 }
            }
        }

        if( i < 3 ) {
            continue;
        }

        break;
    }

    /* ̓f[^e[u Zbg */
    keisoku_indata[ idx ].huka = atoi( work[ 0 ] );
    keisoku_indata[ idx ].set = atoi( work[ 1 ] );
    keisoku_indata[ idx ].kaisuu = atoi( work[ 2 ] );

    return;
}



/************************************/
/* vL^͏                 */
/*   ͌vf[^@\       */
/*                                  */
/*   p[^ : R[h        */
/*                t              */
/*   ^[   : Ȃ              */
/************************************/
static void keisoku_data_disp( int kaiin_code, char *keisoku_date )
{
    int     i;      /* CfbNX      */

    printf( "\n ** ͌vlf[^ **" );
    printf( "\n R[h %3d", kaiin_code );
    printf( "\n t       %4.4s-%2.2s-%2.2s", 
        ( keisoku_date + 0 ), ( keisoku_date + 4 ), ( keisoku_date + 6 ) );

    printf( "\n\n ^     Zbg   " );

    for( i = 0; i < 5; i++ ) {
        printf( "\n   %d     %3d    %3d     %3d", i + 1, 
            keisoku_indata[ i ].huka,
            keisoku_indata[ i ].set,
            keisoku_indata[ i ].kaisuu );
    }

    return;
}



/************************************/
/* vL^͏                 */
/*   ^wvZ               */
/*                                  */
/*   p[^ : ^w          */
/*   ^[   : Ȃ              */
/************************************/
static void undou_sisuu_keisan( int *undou_sisuu )
{
    int     i;              /* CfbNX  */
    double  sisuu;          /* vZ[N    */
    double  sisuu_total;    /* vZlv    */
    static  double  huka_sisuu[ 5 ] = { 0.24, 0.36, 0.52, 1.05, 2.13 };

    sisuu_total = 0.0;
    for( i = 0; i < 5; i++ ) {

        /*  1ȉ ? */
        if( keisoku_indata[ i ].kaisuu <= 1 ) {
            continue;
        }

        sisuu = huka_sisuu[ i ] * (double)keisoku_indata[ i ].huka * 
               (double)keisoku_indata[ i ].set *
               ((pow( (double)keisoku_indata[ i ].kaisuu, 2.0 )) /
               ((double)keisoku_indata[ i ].kaisuu - 1.0));

        /* VO}(݌v)̌vZ */
        sisuu_total += sisuu;
    }

    /* ̎Zo */
    *undou_sisuu = (int)sqrt( sisuu_total );

    return;
}



/************************************/
/* vL^͏                 */
/*   lvf[^\@XV     */
/*                                  */
/*   p[^ : R[h        */
/*                t              */
/*                ^w          */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int kojin_data_update( int kaiin_code, char *keisoku_date, int undou_sisuu )
{
    int     ret;                        /* ^[R[h         */
    long    fptr;                       /* vf[^|C^     */
    FILE    *fp;                        /* t@C|C^       */
    char    *fname = KEISOKU_TBL_NAME;  /* vf[^\t@C   */
    int     i;                          /* CfbNX           */

    /* 1 ? */
    if( kojin_keisoku_tbl.count <= 0 ) {
        strcpy( kojin_keisoku_tbl.first_date, keisoku_date );
        kojin_keisoku_tbl.first_data = undou_sisuu;

        strcpy( kojin_keisoku_tbl.max_date, keisoku_date );
        kojin_keisoku_tbl.max_data = undou_sisuu;
    }
    else {

        /* ōL^ ? */
        if( kojin_keisoku_tbl.max_data < undou_sisuu ) {
            strcpy( kojin_keisoku_tbl.max_date, keisoku_date );
            kojin_keisoku_tbl.max_data = undou_sisuu;
        }
        for (i = sizeof kojin_keisoku_tbl.soku_data / sizeof(int) - 1; i > 0; i-- )
            kojin_keisoku_tbl.soku_data[ i ] = kojin_keisoku_tbl.soku_data[ i - 1 ];
    }

    strcpy( kojin_keisoku_tbl.soku_date, keisoku_date );
    kojin_keisoku_tbl.soku_data[ 0 ] = undou_sisuu;
    kojin_keisoku_tbl.count++;

    /* vf[^\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "r+b" )) == NULL ) {
        printf( "\n vf[^\t@C OPEN G[" );
        return NG;
    }

    /* Yf[^|C^ Zbg */
    fptr = ( codedata_tbl[ kaiin_code - 1 ] - 1 ) * 
        sizeof( struct KEISOKU_TBL );

    /* vf[^\t@C SEEK -> OK łȂ ? */
    if( (ret = fseek( fp, fptr, SEEK_SET )) != OK ) {
        printf( "\n vf[^\t@C SEEK G[" );

        /* vf[^\t@C CLOSE */
        fclose( fp );
        return NG;
    }

    /* vf[^\t@C WRITE -> 1ȊO ? */
    if( (ret = fwrite( (char *)&kojin_keisoku_tbl, sizeof( kojin_keisoku_tbl ),
               1, fp )) != 1 ) {
        printf( "\n vf[^\t@C WRITE G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* vf[^\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* vL^͏                 */
/*   vʏʃ\[gE\   */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int keisoku_rank( void )
{
    int     ret;                        /* ^[R[h         */
    int     i;                          /* CfbNX           */
    FILE    *fp;                        /* t@C|C^       */
    char    *fname = KEISOKU_TBL_NAME;  /* vf[^\t@C   */

    /* vf[^\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n vf[^\t@C OPEN G[" );
        return NG;
    }

    i = 0;
    for( ; ; ) {

        /* vf[^\t@C READ -> 1ȊO ? */
        if( (ret = fread( (char *)&sort_keisoku_tbl[ i ],
                   sizeof( struct KEISOKU_TBL ), 1, fp )) != 1 ) {

            /* READ G[ ? */
            if( ferror( fp ) != 0 ) {
                printf( "\n vf[^\t@C READ G[" );
                ret = NG;
            }
            else {
                /* t@C EOF łȂ ? */
                if( feof( fp ) == 0 ) {
                    printf( "\n vf[^\t@C READ G[" );
                    ret = NG;
                }
                else {
                    ret = OK;
                }
            }
        }

        /* READ G[ ? */
        if( ret == NG ) {
            break;
        }

        /* vf[^ ? */
        if( sort_keisoku_tbl[ i ].count != 0 ) {
            i++;
        }

        /* eof ? */
        if( ret == OK ) {
            break;
        }
    }

    /* vf[^\t@C CLOSE */
    fclose( fp );

    if( ret == OK ) {
        /* vf[^\[g */
        keisoku_data_sort( i );
        /* vf[^\[gʕ\ */
        keisoku_sort_disp( i );
    }

    return ret;
}



/************************************/
/* vL^͏                 */
/*   vʏʃ\[g         */
/*                                  */
/*   p[^ : vf[^    */
/*   ^[   : Ȃ              */
/************************************/
static void keisoku_data_sort( int cnt )
{
    int     i;                      /* CfbNX      */
    int     j;                      /* CfbNX      */
    struct  KEISOKU_TBL  work;      /* XbvpGA  */

    /* f[^\[g */
    for( i = 0; i < cnt - 1; i++ ) {
        for( j = i + 1; j < cnt; j++ ) {
            if( sort_keisoku_tbl[ i ].max_data < 
                sort_keisoku_tbl[ j ].max_data ) {

                work = sort_keisoku_tbl[ i ];
                sort_keisoku_tbl[ i ] = sort_keisoku_tbl[ j ];
                sort_keisoku_tbl[ j ] = work;
            }
        }
    }
    return;
}



/************************************/
/* vL^͏                 */
/*   vʏʕ\           */
/*                                  */
/*   p[^ : vf[^    */
/*   ^[   : Ȃ              */
/************************************/
static void keisoku_sort_disp( int cnt )
{
    int     i;  /* CfbNX  */

    printf( "\n\n ** ʕ\ **" );
    printf( "\n  R[h ōf[^     t" );

    for( i = 0; i < cnt; i++ ) {

        /* 10ʂ܂ŕ\ */
        if( i >= 10 ) {
            break;
        }

        printf( "\n   %2d   %3d         %4d     %4.4s-%2.2s-%2.2s", i + 1,
            sort_keisoku_tbl[ i ].kaiin_code,
            sort_keisoku_tbl[ i ].max_data,
            &sort_keisoku_tbl[ i ].max_date[ 0 ],
            &sort_keisoku_tbl[ i ].max_date[ 4 ],
            &sort_keisoku_tbl[ i ].max_date[ 6 ] );
    }
    return;
}
