/************************************/
/*  nyuukai.c                       */
/*    o^vO        */
/************************************/
#include <stdio.h>
#include <string.h>

#include "common.h"
#include "main.h"
#include "nyuukai.h"

extern int akicode_tbl[ MEMBER_MAX + 1 ];        /* 󂫃R[h\          */
extern int codedata_tbl[ MEMBER_MAX ];           /* R[hEf[^Ώƕ\  */
extern struct KEISOKU_TBL kojin_keisoku_tbl;     /* lʌvf[^\    */

/***********************************/
/* o^                    */
/*   C[`                */
/*                                 */
/*   p[^ : Ȃ             */
/*   ^[   : 0:OK             */
/*               -1:NG             */
/***********************************/
int nyuukai_touroku( void )
{
    int    ret;             /* ^[R[h      */
    int    kaiin_code;      /* o^R[h      */
    long   fptr;            /* t@C|C^    */
    char   msg[ 64 ];       /* bZ[WGA    */

    /* 󂫃R[h\ READ -> NG ? */
    if( (ret = akicode_tbl_read( )) == NG ) {
        return ret;
    }

    /* 󂫃R[h ? */
    if( akicode_tbl[ 0 ] <= 0 ) {
        printf( "\n cOȂ炽o[̋󂫂܂\n" );
        ret = OK;
        return ret;
    }

    /* 󂫃R[hmF */
    sprintf( msg, "\n R[h %d łB낵ł( Y/N )", akicode_tbl[ 1 ] );

    if( (ret = kakunin_input( msg )) == OK ) {
        /* o^R[hޔ */
        kaiin_code = akicode_tbl[ 1 ];

        /* 󂫃R[h\XV -> OK ? */
        if( (ret = akicode_tbl_update( )) == OK ) {

            /* vf[^\ǉ -> OK ? */
            if( (ret = keisoku_tbl_add( &fptr, kaiin_code )) == OK ) {

                /* R[hEf[^Ώƕ\XV */
                ret = codedata_tbl_update( kaiin_code, fptr );
            }
        }
    }

    if( ret == OK ) {
        printf( "\n o^I܂" );
    }

    return ret;
}



/************************************/
/* o^                     */
/*   󂫃R[h\@XV         */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int akicode_tbl_update( void )
{
    int     ret;                        /* ^[R[h       */
    int     i;                          /* CfbNX         */
    int     cnt;                        /* 󂫃R[h       */
    FILE    *fp;                        /* t@C|C^     */
    char    *fname = AKICODE_TBL_NAME;  /* 󂫃R[h\t@C */

    /* 󂫃R[hZbg */
    cnt = akicode_tbl[ 0 ];

    /* 󂫃R[hҏW */
    for( i = 1; i < cnt; i++ ) {
        if( akicode_tbl[ i + 1 ] == 0 ) {
            break;
        }
        akicode_tbl[ i ] = akicode_tbl[ i + 1 ];
    }

    akicode_tbl[ i ] = 0;

    /* 󂫃R[hZbg */
    akicode_tbl[ 0 ] = cnt - 1;

    /* 󂫃R[h\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "wb" )) == NULL ) {
        printf( "\n 󂫃R[h\t@C OPEN G[" );
        return NG;
    }

    /* 󂫃R[h\t@C WRITE -> 1ȊO ? */
    if( (ret = fwrite( (char *)akicode_tbl,
               sizeof( int ) * (akicode_tbl[ 0 ] + 1), 1, fp )) != 1 ) {
        printf( "\n 󂫃R[h\t@C WRITE G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* 󂫃R[h\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* o^                     */
/*   vf[^\@ǉ         */
/*                                  */
/*   p[^ : vf[^|C^*/
/*                o^R[h    */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int keisoku_tbl_add( long *fptr, int kaiin_code )
{
    int     ret;                        /* ^[R[h         */
    FILE    *fp;                        /* t@C|C^       */
    char    *fname = KEISOKU_TBL_NAME;  /* vf[^\t@C   */

    /* vf[^\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "a+b" )) == NULL ) {
        printf( "\n vf[^\t@C OPEN G[" );
        return NG;
    }

    /* vf[^\t@C SEEK -> OK łȂ ? */
    if( (ret = fseek( fp, 0L, SEEK_END )) != OK ) {
        printf( "\n vf[^\t@C SEEK G[" );
        /* vf[^\t@C CLOSE */
        fclose( fp );
        return NG;
    }

    /* t@C|C^擾 */
    *fptr = ftell( fp );

    /* vf[^\NA */
    kojin_keisoku_tbl = init_kojin_keisoku_tbl();

    /* R[hZbg */
    kojin_keisoku_tbl.kaiin_code = kaiin_code;

    /* vf[^\t@C WRITE -> 1ȊO ? */
    if( (ret = fwrite( (char *)&kojin_keisoku_tbl, sizeof( kojin_keisoku_tbl ),
               1, fp )) != 1 ) {
        printf( "\n vf[^\t@C WRITE G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* vf[^\t@C CLOSE */
    fclose( fp );

    return ret;
}



/*****************************************/
/* o^                     @@ */
/*   R[hEf[^Ώƕ\@XV      */
/*                                       */
/*   p[^ : o^R[h         */
/*                vf[^|C^     */
/*   ^[   : 0:OK                   */
/*               -1:NG                   */
/*****************************************/
static int codedata_tbl_update( int kaiin_code, long fptr )
{
    int     ret;                        /* ^[R[h                */
    FILE    *fp;                        /* t@C|C^              */
    char    *fname = CODEDATA_TBL_NAME; /* R[hEf[^Ώƕ\t@C  */

    /* R[hEf[^Ώƕ\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "r+b" )) == NULL ) {
        printf( "\n R[hEf[^Ώƕ\t@C OPEN G[" );
        return NG;
    }

    /* R[hEf[^Ώƕ\t@C READ -> 1ȊO ? */
    if( (ret = fread( (char *)codedata_tbl, sizeof( codedata_tbl ), 1, fp ) )
               != 1 ) {
        printf( "\n R[hEf[^Ώƕ\t@C READ G[" );
        ret = NG;
    }
    else {
        /* Yf[^|C^Zbg */
        codedata_tbl[ kaiin_code - 1 ] = 
            (int)( (fptr / sizeof( struct KEISOKU_TBL )) + 1 );

        /* t@C|C^擪 SEEK -> OK łȂ ? */
        if( (ret = fseek( fp, 0L, SEEK_SET )) != OK ) {
            printf( "\n R[hEf[^Ώƕ\t@C SEEK G[" );

            /* R[hEf[^Ώƕ\t@C CLOSE */
            fclose( fp );
            return NG;
        }

        /* R[hEf[^Ώƕ\t@C WRITE -> 1ȊO ? */
        if( (ret = fwrite( (char *)codedata_tbl, sizeof( codedata_tbl ), 1,
                   fp )) != 1 ) {
            printf( "\n R[hEf[^Ώƕ\t@C WRITE G[" );
            ret = NG;
        }
        else {
            ret = OK;
        }
    }

    /* R[hEf[^Ώƕ\t@C CLOSE */
    fclose( fp );

    return ret;
}
