/************************************/
/*  sakujyo.c                       */
/*    o^폜vO        */
/************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "common.h"
#include "main.h"
#include "sakujyo.h"

extern int akicode_tbl[ MEMBER_MAX + 1 ];      /* 󂫃R[h\           */
extern int codedata_tbl[ MEMBER_MAX ];         /* R[hEf[^Ώƕ\   */
extern struct KEISOKU_TBL kojin_keisoku_tbl;   /* lʌvf[^\     */

/************************************/
/* o^폜                     */
/*   C[`                 */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
int touroku_sakujyo( void )
{
    int     ret;            /* ^[R[h   */
    int     loop = TRUE;    /* [vtO     */
    int     kaiin_code;     /* 폜R[h   */
    char    work[ 128 ];    /* ̓[N       */

    while( loop ) {
        printf( "\n މ҂̉R[h͂Ă" );
        printf( "\n ? " );

        /* R[h */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* j[bNE`FbN -> lȊO ? */
        if( strspn( work, "1234567890" ) < strlen( work ) ) {
            printf( "\n lȊO͂܂" );
            continue;
        }

        /* ͔͈̓`FbN -> ( 0 < kaiin_code <= MEMBER_MAX ) ? */
        kaiin_code = atoi( work );
        if( kaiin_code > MEMBER_MAX || kaiin_code <= 0 ) {
            printf( "\n ̓~Xł" );
            continue;
        }

        /* R[hEf[^Ώƕ\폜 -> OK ? */
        if( (ret = codedata_tbl_delete( kaiin_code )) == OK ) {
            /* 󂫃R[h\ǉ -> OK ? */
            if( (ret = akicode_tbl_add( kaiin_code )) == OK ) {
                /* Cɖ߂ */
                loop = FALSE;
            }
        }
        else {
            /* Cɖ߂ */
            loop = FALSE;
        }
    }

    if( ret == OK ) {
        printf( "\n o^폜I܂" );
    }

    return ret;
}



/************************************/
/* o^폜                     */
/*   R[hEf[^Ώƕ\@폜 */
/*                                  */
/*   p[^ : 폜R[h    */
/*   ^[   : 0:OK              */
/*                1:CANCEL          */
/*               -1:NG              */
/************************************/
static int codedata_tbl_delete( int kaiin_code )
{
    int     ret;                        /* ^[R[h                */
    int     i;                          /* CfbNX                  */
    char    msg[ 64 ];                  /* bZ[WGA              */
    FILE    *fp;                        /* t@C|C^              */
    char    *fname = CODEDATA_TBL_NAME; /* R[hEf[^Ώƕ\t@C  */

    /* R[hEf[^Ώƕ\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "r+b" )) == NULL ) {
        printf( "\n R[hEf[^Ώƕ\t@C OPEN G[" );
        return NG;
    }

    /* R[hEf[^Ώƕ\t@C READ -> 1ȊO ? */
    if( (ret = fread( (char *)codedata_tbl, sizeof( codedata_tbl ), 1, fp ) )
               != 1 ) {
        /* READ G[ */
        printf( "\n R[hEf[^Ώƕ\t@C READ G[" );

        /* R[hEf[^Ώƕ\t@C CLOSE */
        fclose( fp );
        return NG;
    }

    /* o^`FbN -> o^ ? */
    if( codedata_tbl[ kaiin_code - 1 ] == 0 ) {
        printf( "\n ̉R[h͖o^ł" );

        /* R[hEf[^Ώƕ\t@C CLOSE */
        fclose( fp );
        return CANCEL;
    }

    /* vf[^\ READ -> NG ? */
    if( (ret = kojin_data_read( kaiin_code )) == NG ) {
        /* R[hEf[^Ώƕ\t@C CLOSE */
        fclose( fp );
        return ret;
    }

    /* vf[^\ */
    kojin_data_disp( kaiin_code, "\n ** 폜f[^ **" );

    /* vf[^\폜mF */
    sprintf( msg, "\n\n ̃f[^폜܂B낵ł( Y/N )" );

    if( (ret = kakunin_input( msg )) == OK ) {

        /* vf[^\폜 -> OK ? */
        if( (ret = kojin_data_delete( kaiin_code )) == OK ) {

            /* vf[^|C^XV */
            for( i = 0; i < MEMBER_MAX; i++ ) {
                if( codedata_tbl[ i ] > codedata_tbl[ kaiin_code - 1 ] ) {
                    codedata_tbl[ i ]--;
                }
            }

            /* vf[^|C^NA */
            codedata_tbl[ kaiin_code - 1 ] = 0;

            /* R[hEf[^Ώƕ\t@C̐擪ʒu SEEK -> OK ? */
            if( (ret = fseek( fp, 0L, SEEK_SET )) == OK ) {

                /* R[hEf[^Ώƕ\t@C WRITE -> 1ȊO ? */
                if( (ret = fwrite( (char *)codedata_tbl,
                           sizeof( codedata_tbl ),1, fp )) != 1 ) {
                    printf( "\n R[hEf[^Ώƕ\t@C WRITE G[" );
                    ret = NG;
                }
                else {
                    ret = OK;
                }
            }
            else {
                printf( "\n R[hEf[^Ώƕ\t@C SEEK G[" );
                ret = NG;
            }
        }
    }
    else {
        /* ~ */
        ret = CANCEL;
    }

    /* R[hEf[^Ώƕ\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* o^폜                     */
/*   lvf[^\@폜     */
/*                                  */
/*   p[^ : 폜R[h    */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int kojin_data_delete( int kaiin_code )
{
    int     ret;                         /* ^[R[h                */
    int     i;                           /* CfbNX                  */
    FILE    *fp;                         /* vf[^\t@C|C^  */
    FILE    *tmp;                        /* e|t@C|C^    */
    char    *fname = KEISOKU_TBL_NAME;   /* vf[^\t@C          */
    char    *tmpfl = "keisoku.tmp";      /* e|t@C            */

    /* vf[^\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n vf[^\t@C OPEN G[" );
        return NG;
    }

    /* e|t@C OPEN -> NULL ? */
    if( (tmp = fopen( tmpfl, "wb" )) == NULL ) {
        printf( "\n e|t@C OPEN G[" );
        fclose( fp );
        return NG;
    }

    i = 0;
    for( ; ; ) {

        /* vf[^\t@C READ -> 1ȊO ? */
        if( (ret = fread( (char *)&kojin_keisoku_tbl,
                   sizeof( kojin_keisoku_tbl ), 1, fp )) != 1 ) {

            /* READ G[ ? */
            if( ferror( fp ) != 0 ) {
                printf( "\n vf[^\t@C READ G[" );
                ret = NG;
            }
            else {
                /* t@C EOF łȂ ? */
                if( feof( fp ) == 0 ) {
                    printf( "\n vf[^\t@C READ G[" );
                    ret = NG;
                }
                else {
                   ret = OK;
                }
            }
            break;
        }

        /* 폜f[^ ? */
        if( kaiin_code == kojin_keisoku_tbl.kaiin_code ) {
            continue;
        }

        /* e|t@C WRITE -> 1ȊO ? */
        if( (ret = fwrite( (char *)&kojin_keisoku_tbl,
                   sizeof( kojin_keisoku_tbl ), 1, tmp )) != 1 ) {
            printf( "\n vf[^\t@C WRITE G[" );
            ret = NG;
            break;
        }
        i++;
    }

    /* e|t@C CLOSE */
    fclose( tmp );

    /* vf[^\t@C CLOSE */
    fclose( fp );

    /* I ? */
    if( ret == OK ) {

        /* vf[^\t@C DELETE -> 0ȊO ? */
        if( (ret = remove( fname )) != 0 ) {
            printf( "\n vf[^\t@C폜G[" );
            ret = NG;
        }
        else {
            /* ݃f[^ ? */
            if( i > 0 ) {

                /* e|t@Cvf[^\t@CɃl[ -> 0ȊO ? */
                if( (ret = rename( tmpfl, fname )) != 0 ) {
                    printf( "\n vf[^\t@Cl[G[" );
                    ret = NG;
                }
            }
            else {
                /* e|t@C폜 */
                remove( tmpfl );
            }
        }
    }
    else {
        /* e|t@C폜 */
        remove( tmpfl );
    }

    return ret;
}



/************************************/
/* o^폜                     */
/*   󂫃R[h\@ǉ         */
/*                                  */
/*   p[^ : 폜R[h    */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int akicode_tbl_add( int kaiin_code )
{
    int     ret;                        /* ^[R[h        */
    int     cnt;                        /* 󂫃R[h        */
    FILE    *fp;                        /* t@C|C^      */
    char    *fname = AKICODE_TBL_NAME;  /* 󂫃R[h\t@C  */

    /* 󂫃R[h\ READ -> NG ? */
    if( (ret = akicode_tbl_read( )) == NG ) {
        return ret;
    }

    /* 󂫃R[hZbg */
    cnt = akicode_tbl[ 0 ];

    /* 󂫃R[he[uZbg */
    akicode_tbl[ cnt + 1 ] = kaiin_code;

    /* 󂫃R[hZbg */
    akicode_tbl[ 0 ] = cnt + 1;

    /* 󂫃R[h\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "wb" )) == NULL ) {
        printf( "\n 󂫃R[h\t@C OPEN G[" );
        return NG;
    }

    /* 󂫃R[h\t@C WRITE -> 1ȊO ? */
    if( (ret = fwrite( (char *)akicode_tbl,
               sizeof( int ) * ( akicode_tbl[ 0 ] + 1 ), 1, fp )) != 1 ) {
        printf( "\n 󂫃R[h\t@C WRITE G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* 󂫃R[h\t@C CLOSE */
    fclose( fp );

    return ret;
}
